package org.dataglot.web.xhtml.marshaller;

import java.io.File;
import java.io.OutputStream;
import java.io.Writer;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.stream.XMLEventWriter;
import javax.xml.stream.XMLStreamWriter;
import javax.xml.transform.Result;
import org.dataglot.web.xhtml.jaxb.Html;
import org.w3c.dom.Node;
import org.xml.sax.ContentHandler;

public class XhtmlMarshaller
{
	public XhtmlMarshaller()
	{
		try
		{
			jaxbContext = JAXBContext.newInstance(Html.class);
		}
		catch (final JAXBException e)
		{
			throw new RuntimeException(e);
		}
	}

	public XhtmlMarshaller formattedOutput(final boolean formattedOutput)
	{
		this.formattedOutput = formattedOutput;
		return this;
	}

	public XhtmlMarshaller fragment(final boolean fragment)
	{
		this.fragment = fragment;
		return this;
	}

	public void marshal(final Html html, final ContentHandler out)
	{
		try
		{
			final Marshaller marshaller = createMarshaller();
			marshaller.marshal(html, out);
		}
		catch (final JAXBException e)
		{
			throw new RuntimeException(e);
		}
	}

	public void marshal(final Html html, final File out)
	{
		try
		{
			final Marshaller marshaller = createMarshaller();
			marshaller.marshal(html, out);
		}
		catch (final JAXBException e)
		{
			throw new RuntimeException(e);
		}
	}

	public void marshal(final Html html, final Node out)
	{
		try
		{
			final Marshaller marshaller = createMarshaller();
			marshaller.marshal(html, out);
		}
		catch (final JAXBException e)
		{
			throw new RuntimeException(e);
		}
	}

	public void marshal(final Html html, final OutputStream out)
	{
		try
		{
			final Marshaller marshaller = createMarshaller();
			marshaller.marshal(html, out);
		}
		catch (final JAXBException e)
		{
			throw new RuntimeException(e);
		}
	}

	public void marshal(final Html html, final Result out)
	{
		try
		{
			final Marshaller marshaller = createMarshaller();
			marshaller.marshal(html, out);
		}
		catch (final JAXBException e)
		{
			throw new RuntimeException(e);
		}
	}

	public void marshal(final Html html, final Writer out)
	{
		try
		{
			final Marshaller marshaller = createMarshaller();
			marshaller.marshal(html, out);
		}
		catch (final JAXBException e)
		{
			throw new RuntimeException(e);
		}
	}

	public void marshal(final Html html, final XMLEventWriter out)
	{
		try
		{
			final Marshaller marshaller = createMarshaller();
			marshaller.marshal(html, out);
		}
		catch (final JAXBException e)
		{
			throw new RuntimeException(e);
		}
	}

	public void marshal(final Html html, final XMLStreamWriter out)
	{
		try
		{
			final Marshaller marshaller = createMarshaller();
			marshaller.marshal(html, out);
		}
		catch (final JAXBException e)
		{
			throw new RuntimeException(e);
		}
	}

	private Marshaller createMarshaller() throws JAXBException
	{
		final Marshaller marshaller = jaxbContext.createMarshaller();
		if (formattedOutput)
		{
			marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
		}
		if (fragment)
		{
			marshaller.setProperty(Marshaller.JAXB_FRAGMENT, Boolean.TRUE);
		}
		return marshaller;
	}

	private boolean formattedOutput = false;

	private boolean fragment = false;

	private final JAXBContext jaxbContext;
}
